<?php
/**
 * MoonyǻѤ륢󥯥饹
 * ƥץ졼ȥեμưԤޤ
 * 
 * @access public
 * @license http://www.opensource.org/licenses/bsd-license.php The BSD License
 * @author YAMAOKA Hiroyuki <yamaoka@catwalker.jp>
 */

define('MOONY_ROOT_DIR', dirname(dirname(__FILE__)));

require_once MOONY_ROOT_DIR . '/lib/moony/Moony_Config.php';

if ($_SERVER['argc'] != 2) {
    $message = "Parameter Error...\n";
    $message .= "usage: /path/to/php generate.php [action_name]\n";
}

$action_name = $_SERVER['argv'][1];

$action_file = MOONY_ACTION_DIR . '/' . $action_name . 'Action.' . MOONY_ACTION_EXT;
$template_file = MOONY_SMARTY_TEMPLATE_DIR . '/' . $action_name . '.' . MOONY_SMARTY_TEMPLATE_EXT;

if (file_exists($action_file)) {
    die("Error: Action Class File Already Exists\n");
}
if (file_exists($template_file)) {
    die("Error: Template File Already Exists\n");
}

$skelton_dir = MOONY_ROOT_DIR . '/_codegen/skelton';
$action_tpl = file_get_contents($skelton_dir . '/action.skl');
$template_tpl = file_get_contents($skelton_dir . '/template.skl');

$action_content = sprintf($action_tpl, $action_name . 'Action');
$template_content = sprintf($template_tpl, $action_name);

$fp = fopen($action_file, 'w');
fputs($fp, $action_content);
fclose($fp);

$fp = fopen($template_file, 'w');
fputs($fp, $template_content);
fclose($fp);

echo "Skelton for '$action_name' Successfully Generated!\n";
?>
