<?php
/**
 * ȥ饯饹Ǥ
 * ꡦưԤޤ
 * 
 * @access public
 * @package moony.core
 * @license http://www.opensource.org/licenses/bsd-license.php The BSD License
 * @author YAMAOKA Hiroyuki <yamaoka@catwalker.jp>
 */
class Moony_Controller {

    /**
     * 󥹥ȥ饯Ǥ
     * 
     * @access public
     */
    function Moony_Controller() {}

    /**
     * ºݤνԤޤưޤ
     * ޤꤵ줿б륯饹¸ߤʤϡ
     * ̵˥̾ɳդƥץ졼Ȥɽޤ
     * 
     * @access public
     * @param string $action_name ̾
     * @param array $url URLϤ줿ѥ᡼
     */
    function process($action_name, $url) {

        // HTTPإå
        header('X-Framework: Moony/' . MOONY_VERSION);

        // 顼ϥɥ
        $error_handler =& new Moony_ErrorHandler();
        $error_handler->register();

        // Request饹ѥ᡼Ǽ
        $request =& new Moony_Request();
        $request->store();

        // Session饹å󳫻
        $session =& new Moony_Session();
        $session->start();

        // ƥȥ饹˳Ǽ
        $context =& new Moony_Context();
        $context->setRequest(&$request);
        $context->setSession(&$session);
        $context->setUrl($url);

        // View饹
        $view =& new Moony_View();
        $view->setTemplate($action_name . '.' . MOONY_SMARTY_TEMPLATE_EXT);

        // 󥯥饹˴ؤȤΩ
        $action_class_name = $action_name . 'Action';
        $action_class_path = MOONY_ACTION_DIR . DIRECTORY_SEPARATOR . $action_class_name . '.' . MOONY_ACTION_EXT;

        if (file_exists($action_class_path)) {
            // ¹
            include_once $action_class_path;
            $action =& new $action_class_name;
            $action->execute(&$context, &$view);
        } else {
            // 󥯥饹¸ߤʤ硢˱ƥå
            if (MOONY_SMARTY_USE_CACHE_WITHOUT_ACTION) {
                $view->cache();
            }
        }

        // ɽ
        if (!$view->isDisabled()) {
            $view->display();
        }
    }
}
?>
