<?php
/**
 * åǼ륯饹Ǥ
 * 
 * @access public
 * @package moony.core
 * @license http://www.opensource.org/licenses/bsd-license.php The BSD License
 * @author YAMAOKA Hiroyuki <yamaoka@catwalker.jp>
 */
class Moony_Session {

    /** @var bool å󤬳ϤƤ뤫ɤ */
    var $_has_started = false;

    /**
     * 󥹥ȥ饯Ǥ
     * 
     * @access public
     */
    function Moony_Session() {}

    /**
     * å򳫻Ϥޤ
     * åID
     * Ťåեޤ
     * 
     * @access public
     */
    function start() {

        // ϡåͤ¸
        session_start();
        $stored = serialize($_SESSION);

        // ˴åID
        session_destroy();
        session_id(md5(uniqid(rand(), true)));

        // Ƴå
        session_start();
        $_SESSION = unserialize($stored);

        $this->_has_started = true;
    }

    /**
     * åλޤ
     * 
     * @access public
     * @return ˽λ<code>true</code>
     */
    function destroy() {

        if (!$this->_has_started) {
            return true;
        }

        $_SESSION = array();

        if (isset($_COOKIE[session_name()])) {
            setcookie(session_name(), '', time() - 42000, '/');
        }

        session_destroy();
        $this->_has_started = false;

        return true;
    }

    /**
     * åID֤ޤ
     * å󤬳ϤƤʤ硢
     * ̵<code>null</code>֤ޤ
     *
     * @access public
     * @return string åID
     */
    function getId() {

        if (!$this->_has_started) {
            return null;
        }

        return session_id();
    }

    /**
     * å˳Ǽ줿ͤޤ
     * ꤵ줿ɳդͤꤵƤʤ硢
     * ֤ͤޤ
     * 
     * @access public
     * @param string $key Ǽ
     * @param mixed $alt 
     * @return mixed Ǽ
     */
    function get($key, $alt = null) {

        if (!$this->_has_started) {
            return $alt;
        }

        if (!$this->exists($key)) {
            return $alt;
        }

        return $_SESSION[$key];
    }

    /**
     * åͤꤷޤ
     * 
     * @access public
     * @param string $key Ǽ
     * @param mixed $value Ǽ
     * @return bool ˽λ<code>true</code>
     */
    function set($key, $value) {

        if (!$this->_has_started) {
            return false;
        }

        $_SESSION[$key] = $value;
        return true;
    }

    /**
     * ꤵ줿˥åͤ
     * ǼƤ뤫ɤ֤ޤ
     *
     * @access public
     * @param string $key å󥭡
     * @return ¸ߤ<code>true</code>
     */
    function exists($key) {
        return isset($_SESSION[$key]);
    }

    /**
     * å󤫤ͤޤ
     * 
     * @access public
     * @param string $key Ǽ
     * @return bool ˽λ<code>true</code>
     */
    function remove($key) {

        if (!$this->_has_started) {
            return false;
        }

        unset($_SESSION[$key]);
        return true;
    }
}
?>